<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>screenlets.plugins.AmazonCoverArtSearch</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="screenlets-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            >Screenlets 0.1.2</th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="screenlets-module.html">Package&nbsp;screenlets</a> ::
        <a href="screenlets.plugins-module.html">Package&nbsp;plugins</a> ::
        Module&nbsp;AmazonCoverArtSearch
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
        <tr><td align="right"><span class="options"
            >[<a href="frames.html" target="_top">frames</a
            >]&nbsp;|&nbsp;<a href="screenlets.plugins.AmazonCoverArtSearch-pysrc.html"
            target="_top">no&nbsp;frames</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="screenlets.plugins.AmazonCoverArtSearch-module.html">Module screenlets.plugins.AmazonCoverArtSearch</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment"># -*- Mode: python; coding: utf-8; tab-width: 8; indent-tabs-mode: t; -*- </tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment">#</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># Copyright (C) 2006 - Gareth Murphy, Martin Szulecki</tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment">#</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># it under the terms of the GNU General Public License as published by</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># the Free Software Foundation; either version 2, or (at your option)</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># any later version.</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># </tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># GNU General Public License for more details.</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment">#</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># You should have received a copy of the GNU General Public License</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># along with this program; if not, write to the Free Software</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.</tt> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"><tt class="py-comment"></tt> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt class="py-name">xml</tt><tt class="py-op">.</tt><tt class="py-name">dom</tt> <tt class="py-keyword">import</tt> <tt class="py-name">minidom</tt> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">re</tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">locale</tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">urllib</tt> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"><tt id="link-0" class="py-name" targets="Variable screenlets.plugins.AmazonCoverArtSearch.LICENSE_KEY=screenlets.plugins.AmazonCoverArtSearch-module.html#LICENSE_KEY"><a title="screenlets.plugins.AmazonCoverArtSearch.LICENSE_KEY" class="py-name" href="#" onclick="return doclink('link-0', 'LICENSE_KEY', 'link-0');">LICENSE_KEY</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"18C3VZN9HCECM5G3HQG2"</tt> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"><tt id="link-1" class="py-name" targets="Variable screenlets.plugins.AmazonCoverArtSearch.DEFAULT_LOCALE=screenlets.plugins.AmazonCoverArtSearch-module.html#DEFAULT_LOCALE"><a title="screenlets.plugins.AmazonCoverArtSearch.DEFAULT_LOCALE" class="py-name" href="#" onclick="return doclink('link-1', 'DEFAULT_LOCALE', 'link-1');">DEFAULT_LOCALE</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"en_US"</tt> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"><tt id="link-2" class="py-name" targets="Variable screenlets.plugins.AmazonCoverArtSearch.ASSOCIATE=screenlets.plugins.AmazonCoverArtSearch-module.html#ASSOCIATE"><a title="screenlets.plugins.AmazonCoverArtSearch.ASSOCIATE" class="py-name" href="#" onclick="return doclink('link-2', 'ASSOCIATE', 'link-2');">ASSOCIATE</a></tt> <tt class="py-op">=</tt> <tt class="py-string">"webservices-20"</tt> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"> </tt>
<a name="Bag"></a><div id="Bag-def"><a name="L29"></a><tt class="py-lineno"> 29</tt> <a class="py-toggle" href="#" id="Bag-toggle" onclick="return toggle('Bag');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.Bag-class.html">Bag</a><tt class="py-op">:</tt> <tt class="py-keyword">pass</tt> </tt>
</div><a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch"></a><div id="AmazonCoverArtSearch-def"><a name="L31"></a><tt class="py-lineno"> 31</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch-toggle" onclick="return toggle('AmazonCoverArtSearch');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html">AmazonCoverArtSearch</a> <tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="AmazonCoverArtSearch-expanded"><a name="AmazonCoverArtSearch.__init__"></a><div id="AmazonCoverArtSearch.__init__-def"><a name="L32"></a><tt class="py-lineno"> 32</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.__init__-toggle" onclick="return toggle('AmazonCoverArtSearch.__init__');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#__init__">__init__</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">loader</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.__init__-expanded"><a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">searching</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">cancel</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-3" class="py-name" targets="Variable screenlets.plugins.CoverSearch.CoverSearch.loader=screenlets.plugins.CoverSearch.CoverSearch-class.html#loader"><a title="screenlets.plugins.CoverSearch.CoverSearch.loader" class="py-name" href="#" onclick="return doclink('link-3', 'loader', 'link-3');">loader</a></tt> <tt class="py-op">=</tt> <tt id="link-4" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.loader" class="py-name" href="#" onclick="return doclink('link-4', 'loader', 'link-3');">loader</a></tt> </tt>
<a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_supportedLocales</tt> <tt class="py-op">=</tt> <tt class="py-op">{</tt> </tt>
<a name="L37"></a><tt class="py-lineno"> 37</tt>  <tt class="py-line">                        <tt class="py-string">"en_US"</tt> <tt class="py-op">:</tt> <tt class="py-op">(</tt><tt class="py-string">"us"</tt><tt class="py-op">,</tt> <tt class="py-string">"xml.amazon.com"</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line">                        <tt class="py-string">"en_GB"</tt> <tt class="py-op">:</tt> <tt class="py-op">(</tt><tt class="py-string">"uk"</tt><tt class="py-op">,</tt> <tt class="py-string">"xml-eu.amazon.com"</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line">                        <tt class="py-string">"de"</tt> <tt class="py-op">:</tt> <tt class="py-op">(</tt><tt class="py-string">"de"</tt><tt class="py-op">,</tt> <tt class="py-string">"xml-eu.amazon.com"</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line">                        <tt class="py-string">"ja"</tt> <tt class="py-op">:</tt> <tt class="py-op">(</tt><tt class="py-string">"jp"</tt><tt class="py-op">,</tt> <tt class="py-string">"xml.amazon.co.jp"</tt><tt class="py-op">)</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line">                <tt class="py-op">}</tt> </tt>
</div><a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.__get_locale"></a><div id="AmazonCoverArtSearch.__get_locale-def"><a name="L43"></a><tt class="py-lineno"> 43</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.__get_locale-toggle" onclick="return toggle('AmazonCoverArtSearch.__get_locale');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#__get_locale">__get_locale</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.__get_locale-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.__get_locale-expanded"><a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line">                <tt class="py-name">default</tt> <tt class="py-op">=</tt> <tt class="py-name">locale</tt><tt class="py-op">.</tt><tt class="py-name">getdefaultlocale</tt> <tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line">                <tt class="py-name">lc_id</tt> <tt class="py-op">=</tt> <tt id="link-5" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.DEFAULT_LOCALE" class="py-name" href="#" onclick="return doclink('link-5', 'DEFAULT_LOCALE', 'link-1');">DEFAULT_LOCALE</a></tt> </tt>
<a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">default</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_supportedLocales</tt><tt class="py-op">.</tt><tt class="py-name">has_key</tt> <tt class="py-op">(</tt><tt class="py-name">default</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L48"></a><tt class="py-lineno"> 48</tt>  <tt class="py-line">                                <tt class="py-name">lc_id</tt> <tt class="py-op">=</tt> <tt class="py-name">default</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line"> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line">                <tt class="py-name">lc_host</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_supportedLocales</tt><tt class="py-op">[</tt><tt class="py-name">lc_id</tt><tt class="py-op">]</tt><tt class="py-op">[</tt><tt class="py-number">1</tt><tt class="py-op">]</tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line">                <tt class="py-name">lc_name</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_supportedLocales</tt><tt class="py-op">[</tt><tt class="py-name">lc_id</tt><tt class="py-op">]</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-op">(</tt><tt class="py-op">(</tt><tt class="py-name">lc_host</tt><tt class="py-op">,</tt> <tt class="py-name">lc_name</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
</div><a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.search"></a><div id="AmazonCoverArtSearch.search-def"><a name="L54"></a><tt class="py-lineno"> 54</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.search-toggle" onclick="return toggle('AmazonCoverArtSearch.search');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#search">search</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">artist</tt><tt class="py-op">,</tt> <tt class="py-param">album</tt><tt class="py-op">,</tt> <tt class="py-param">on_search_completed_callback</tt><tt class="py-op">,</tt> <tt class="py-op">*</tt><tt class="py-param">args</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.search-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.search-expanded"><a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">searching</tt> <tt class="py-op">=</tt> <tt class="py-name">True</tt> </tt>
<a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">cancel</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">on_search_completed_callback</tt> <tt class="py-op">=</tt> <tt class="py-name">on_search_completed_callback</tt> </tt>
<a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">args</tt> <tt class="py-op">=</tt> <tt class="py-name">args</tt> </tt>
<a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line"> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-6" class="py-name" targets="Variable screenlets.plugins.CoverSearch.CoverSearch.album=screenlets.plugins.CoverSearch.CoverSearch-class.html#album"><a title="screenlets.plugins.CoverSearch.CoverSearch.album" class="py-name" href="#" onclick="return doclink('link-6', 'album', 'link-6');">album</a></tt> <tt class="py-op">=</tt> <tt id="link-7" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.album" class="py-name" href="#" onclick="return doclink('link-7', 'album', 'link-6');">album</a></tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-8" class="py-name" targets="Variable screenlets.plugins.CoverSearch.CoverSearch.artist=screenlets.plugins.CoverSearch.CoverSearch-class.html#artist"><a title="screenlets.plugins.CoverSearch.CoverSearch.artist" class="py-name" href="#" onclick="return doclink('link-8', 'artist', 'link-8');">artist</a></tt> <tt class="py-op">=</tt> <tt id="link-9" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.artist" class="py-name" href="#" onclick="return doclink('link-9', 'artist', 'link-8');">artist</a></tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line"> </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line">                <tt class="py-name">st_artist</tt> <tt class="py-op">=</tt> <tt id="link-10" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.artist" class="py-name" href="#" onclick="return doclink('link-10', 'artist', 'link-8');">artist</a></tt> <tt class="py-keyword">or</tt> <tt class="py-string">"Unknown"</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line">                <tt class="py-name">st_album</tt> <tt class="py-op">=</tt> <tt id="link-11" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.album" class="py-name" href="#" onclick="return doclink('link-11', 'album', 'link-6');">album</a></tt> <tt class="py-keyword">or</tt> <tt class="py-string">"Unknown"</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line"> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line">                <tt class="py-comment"># Tidy up</tt> </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line"><tt class="py-comment"></tt> </tt>
<a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line">                <tt class="py-comment"># Replace quote characters</tt> </tt>
<a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-comment"># don't replace single quote: could be important punctuation</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-keyword">for</tt> <tt class="py-name">char</tt> <tt class="py-keyword">in</tt> <tt class="py-op">[</tt><tt class="py-string">"\""</tt><tt class="py-op">]</tt><tt class="py-op">:</tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line">                        <tt class="py-name">st_artist</tt> <tt class="py-op">=</tt> <tt class="py-name">st_artist</tt><tt class="py-op">.</tt><tt id="link-12" class="py-name" targets="Variable screenlets.plugins.Convert.Converter.replace=screenlets.plugins.Convert.Converter-class.html#replace"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-12', 'replace', 'link-12');">replace</a></tt> <tt class="py-op">(</tt><tt class="py-name">char</tt><tt class="py-op">,</tt> <tt class="py-string">''</tt><tt class="py-op">)</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line">                        <tt class="py-name">st_album</tt> <tt class="py-op">=</tt> <tt class="py-name">st_album</tt><tt class="py-op">.</tt><tt id="link-13" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-13', 'replace', 'link-12');">replace</a></tt> <tt class="py-op">(</tt><tt class="py-name">char</tt><tt class="py-op">,</tt> <tt class="py-string">''</tt><tt class="py-op">)</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line"> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line"> </tt>
<a name="L76"></a><tt class="py-lineno"> 76</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">st_album</tt> <tt class="py-op">=</tt> <tt class="py-name">st_album</tt> </tt>
<a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">st_artist</tt> <tt class="py-op">=</tt> <tt class="py-name">st_artist</tt> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line"> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line">                <tt class="py-comment"># Remove variants of Disc/CD [1-9] from album title before search</tt> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-keyword">for</tt> <tt class="py-name">exp</tt> <tt class="py-keyword">in</tt> <tt class="py-op">[</tt><tt class="py-string">"\([Dd]isc *[1-9]+\)"</tt><tt class="py-op">,</tt> <tt class="py-string">"\([Cc][Dd] *[1-9]+\)"</tt><tt class="py-op">]</tt><tt class="py-op">:</tt> </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line">                        <tt class="py-name">p</tt> <tt class="py-op">=</tt> <tt class="py-name">re</tt><tt class="py-op">.</tt><tt class="py-name">compile</tt> <tt class="py-op">(</tt><tt class="py-name">exp</tt><tt class="py-op">)</tt> </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line">                        <tt class="py-name">st_album</tt> <tt class="py-op">=</tt> <tt class="py-name">p</tt><tt class="py-op">.</tt><tt class="py-name">sub</tt> <tt class="py-op">(</tt><tt class="py-string">''</tt><tt class="py-op">,</tt> <tt class="py-name">st_album</tt><tt class="py-op">)</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line"> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line">                <tt class="py-name">st_album_no_vol</tt> <tt class="py-op">=</tt> <tt class="py-name">st_album</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line">                <tt class="py-keyword">for</tt> <tt class="py-name">exp</tt> <tt class="py-keyword">in</tt> <tt class="py-op">[</tt><tt class="py-string">"\(*[Vv]ol.*[1-9]+\)*"</tt><tt class="py-op">]</tt><tt class="py-op">:</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line">                        <tt class="py-name">p</tt> <tt class="py-op">=</tt> <tt class="py-name">re</tt><tt class="py-op">.</tt><tt class="py-name">compile</tt> <tt class="py-op">(</tt><tt class="py-name">exp</tt><tt class="py-op">)</tt> </tt>
<a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line">                        <tt class="py-name">st_album_no_vol</tt> <tt class="py-op">=</tt> <tt class="py-name">p</tt><tt class="py-op">.</tt><tt class="py-name">sub</tt> <tt class="py-op">(</tt><tt class="py-string">''</tt><tt class="py-op">,</tt> <tt class="py-name">st_album_no_vol</tt><tt class="py-op">)</tt> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line"> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">st_album_no_vol</tt> <tt class="py-op">=</tt> <tt class="py-name">st_album_no_vol</tt> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line"> </tt>
<a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line">                <tt class="py-comment"># Save current search's properties</tt> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">search_album</tt> <tt class="py-op">=</tt> <tt class="py-name">st_album</tt> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">search_artist</tt> <tt class="py-op">=</tt> <tt class="py-name">st_artist</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">search_album_no_vol</tt> <tt class="py-op">=</tt> <tt class="py-name">st_album_no_vol</tt> </tt>
<a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line">                 </tt>
<a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line">                <tt class="py-comment"># TODO: Improve to decrease wrong cover downloads, maybe add severity?</tt> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-comment"># Assemble list of search keywords (and thus search queries)</tt> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-keyword">if</tt> <tt class="py-name">st_album</tt> <tt class="py-op">==</tt> <tt class="py-string">"Unknown"</tt><tt class="py-op">:</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s Best of"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_artist</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s Greatest Hits"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_artist</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s Essential"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_artist</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s Collection"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_artist</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_artist</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line">                <tt class="py-keyword">elif</tt> <tt class="py-name">st_artist</tt> <tt class="py-op">==</tt> <tt class="py-string">"Unknown"</tt><tt class="py-op">:</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_album</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-name">st_album_no_vol</tt> <tt class="py-op">!=</tt> <tt class="py-name">st_artist</tt><tt class="py-op">:</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line">                                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_album_no_vol</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"Various %s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_album</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line">                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-name">st_album</tt> <tt class="py-op">!=</tt> <tt class="py-name">st_artist</tt><tt class="py-op">:</tt> </tt>
<a name="L111"></a><tt class="py-lineno">111</tt>  <tt class="py-line">                                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s %s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_artist</tt><tt class="py-op">,</tt> <tt class="py-name">st_album</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line">                                <tt class="py-keyword">if</tt> <tt class="py-name">st_album_no_vol</tt> <tt class="py-op">!=</tt> <tt class="py-name">st_album</tt><tt class="py-op">:</tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line">                                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s %s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_artist</tt><tt class="py-op">,</tt> <tt class="py-name">st_album_no_vol</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line">                                <tt class="py-keyword">if</tt> <tt class="py-op">(</tt><tt class="py-name">st_album</tt> <tt class="py-op">!=</tt> <tt class="py-string">"Unknown"</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line">                                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"Various %s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_album</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L116"></a><tt class="py-lineno">116</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">append</tt> <tt class="py-op">(</tt><tt class="py-string">"%s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">st_artist</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line"> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line">                <tt class="py-comment"># Initiate asynchronous search</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-14" class="py-name" targets="Method screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.search_next()=screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#search_next"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.search_next" class="py-name" href="#" onclick="return doclink('link-14', 'search_next', 'link-14');">search_next</a></tt> <tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">;</tt> </tt>
</div><a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.__build_url"></a><div id="AmazonCoverArtSearch.__build_url-def"><a name="L121"></a><tt class="py-lineno">121</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.__build_url-toggle" onclick="return toggle('AmazonCoverArtSearch.__build_url');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#__build_url">__build_url</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">keyword</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.__build_url-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.__build_url-expanded"><a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line">                <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line">                        <tt class="py-op">(</tt><tt class="py-name">lc_host</tt><tt class="py-op">,</tt> <tt class="py-name">lc_name</tt><tt class="py-op">)</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-15" class="py-name" targets="Method screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__get_locale()=screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#__get_locale"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__get_locale" class="py-name" href="#" onclick="return doclink('link-15', '__get_locale', 'link-15');">__get_locale</a></tt> <tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line">                 </tt>
<a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line">                        <tt class="py-name">url</tt> <tt class="py-op">=</tt> <tt class="py-string">"http://"</tt> <tt class="py-op">+</tt> <tt class="py-name">lc_host</tt> <tt class="py-op">+</tt> <tt class="py-string">"/onca/xml3?f=xml"</tt> </tt>
<a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line">                        <tt class="py-name">url</tt> <tt class="py-op">+=</tt> <tt class="py-string">"&amp;t=%s"</tt> <tt class="py-op">%</tt> <tt id="link-16" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.ASSOCIATE" class="py-name" href="#" onclick="return doclink('link-16', 'ASSOCIATE', 'link-2');">ASSOCIATE</a></tt> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line">                        <tt class="py-name">url</tt> <tt class="py-op">+=</tt> <tt class="py-string">"&amp;dev-t=%s"</tt> <tt class="py-op">%</tt> <tt id="link-17" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.LICENSE_KEY" class="py-name" href="#" onclick="return doclink('link-17', 'LICENSE_KEY', 'link-0');">LICENSE_KEY</a></tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line">                        <tt class="py-name">url</tt> <tt class="py-op">+=</tt> <tt class="py-string">"&amp;type=%s"</tt> <tt class="py-op">%</tt> <tt class="py-string">'lite'</tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line">                        <tt class="py-name">url</tt> <tt class="py-op">+=</tt> <tt class="py-string">"&amp;locale=%s"</tt> <tt class="py-op">%</tt> <tt class="py-name">lc_name</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line">                        <tt class="py-name">url</tt> <tt class="py-op">+=</tt> <tt class="py-string">"&amp;mode=%s"</tt> <tt class="py-op">%</tt> <tt class="py-string">'music'</tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line">                        <tt class="py-name">url</tt> <tt class="py-op">+=</tt> <tt class="py-string">"&amp;%s=%s"</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-string">'KeywordSearch'</tt><tt class="py-op">,</tt> <tt class="py-name">urllib</tt><tt class="py-op">.</tt><tt class="py-name">quote</tt> <tt class="py-op">(</tt><tt class="py-name">keyword</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line"> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line">                        <tt class="py-keyword">return</tt> <tt class="py-name">url</tt> </tt>
<a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line">                <tt class="py-keyword">except</tt><tt class="py-op">:</tt><tt class="py-keyword">return</tt> <tt class="py-name">None</tt> </tt>
</div><a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.search_next"></a><div id="AmazonCoverArtSearch.search_next-def"><a name="L136"></a><tt class="py-lineno">136</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.search_next-toggle" onclick="return toggle('AmazonCoverArtSearch.search_next');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#search_next">search_next</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.search_next-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.search_next-expanded"><a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">searching</tt> <tt class="py-op">=</tt> <tt class="py-name">True</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line">                 </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">len</tt> <tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">)</tt><tt class="py-op">==</tt><tt class="py-number">0</tt><tt class="py-op">:</tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line">                        <tt class="py-name">keyword</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line">                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line">                        <tt class="py-name">keyword</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">keywords</tt><tt class="py-op">.</tt><tt class="py-name">pop</tt> <tt class="py-op">(</tt><tt class="py-number">0</tt><tt class="py-op">)</tt> </tt>
<a name="L143"></a><tt class="py-lineno">143</tt>  <tt class="py-line"> </tt>
<a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">keyword</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line">                        <tt class="py-comment"># No keywords left to search -&gt; no results</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-18" class="py-name" targets="Method screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.on_search_completed()=screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#on_search_completed"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.on_search_completed" class="py-name" href="#" onclick="return doclink('link-18', 'on_search_completed', 'link-18');">on_search_completed</a></tt> <tt class="py-op">(</tt><tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line">                        <tt class="py-name">ret</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line">                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line">                        <tt class="py-comment"># Retrieve search for keyword</tt> </tt>
<a name="L150"></a><tt class="py-lineno">150</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt class="py-name">url</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-19" class="py-name" targets="Method screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__build_url()=screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#__build_url"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__build_url" class="py-name" href="#" onclick="return doclink('link-19', '__build_url', 'link-19');">__build_url</a></tt> <tt class="py-op">(</tt><tt class="py-name">keyword</tt><tt class="py-op">.</tt><tt class="py-name">strip</tt> <tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L151"></a><tt class="py-lineno">151</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-name">url</tt> <tt class="py-op">!=</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line">                                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-20" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.loader" class="py-name" href="#" onclick="return doclink('link-20', 'loader', 'link-3');">loader</a></tt><tt class="py-op">.</tt><tt id="link-21" class="py-name" targets="Method screenlets.plugins.Loader.GnomeVFSAsyncSrc.get_url()=screenlets.plugins.Loader.GnomeVFSAsyncSrc-class.html#get_url,Method screenlets.plugins.Loader.URLLibSrc.get_url()=screenlets.plugins.Loader.URLLibSrc-class.html#get_url"><a title="screenlets.plugins.Loader.GnomeVFSAsyncSrc.get_url
screenlets.plugins.Loader.URLLibSrc.get_url" class="py-name" href="#" onclick="return doclink('link-21', 'get_url', 'link-21');">get_url</a></tt> <tt class="py-op">(</tt><tt class="py-name">url</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-22" class="py-name" targets="Method screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.on_search_response()=screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#on_search_response"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.on_search_response" class="py-name" href="#" onclick="return doclink('link-22', 'on_search_response', 'link-22');">on_search_response</a></tt><tt class="py-op">)</tt> </tt>
<a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line">                                <tt class="py-name">ret</tt> <tt class="py-op">=</tt> <tt class="py-name">True</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line">                        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line">                                <tt class="py-name">ret</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt> </tt>
<a name="L156"></a><tt class="py-lineno">156</tt>  <tt class="py-line"> </tt>
<a name="L157"></a><tt class="py-lineno">157</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">ret</tt> </tt>
</div><a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.__unmarshal"></a><div id="AmazonCoverArtSearch.__unmarshal-def"><a name="L159"></a><tt class="py-lineno">159</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.__unmarshal-toggle" onclick="return toggle('AmazonCoverArtSearch.__unmarshal');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#__unmarshal">__unmarshal</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">element</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.__unmarshal-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.__unmarshal-expanded"><a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line">                <tt class="py-name">rc</tt> <tt class="py-op">=</tt> <tt id="link-23" class="py-name" targets="Class screenlets.plugins.AmazonCoverArtSearch.Bag=screenlets.plugins.AmazonCoverArtSearch.Bag-class.html"><a title="screenlets.plugins.AmazonCoverArtSearch.Bag" class="py-name" href="#" onclick="return doclink('link-23', 'Bag', 'link-23');">Bag</a></tt> <tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">isinstance</tt> <tt class="py-op">(</tt><tt class="py-name">element</tt><tt class="py-op">,</tt> <tt class="py-name">minidom</tt><tt class="py-op">.</tt><tt class="py-name">Element</tt><tt class="py-op">)</tt> <tt class="py-keyword">and</tt> <tt class="py-op">(</tt><tt class="py-name">element</tt><tt class="py-op">.</tt><tt class="py-name">tagName</tt> <tt class="py-op">==</tt> <tt class="py-string">'Details'</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line">                        <tt class="py-name">rc</tt><tt class="py-op">.</tt><tt class="py-name">URL</tt> <tt class="py-op">=</tt> <tt class="py-name">element</tt><tt class="py-op">.</tt><tt class="py-name">attributes</tt><tt class="py-op">[</tt><tt class="py-string">"url"</tt><tt class="py-op">]</tt><tt class="py-op">.</tt><tt class="py-name">value</tt> </tt>
<a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line">                <tt class="py-name">childElements</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-name">e</tt> <tt class="py-keyword">for</tt> <tt class="py-name">e</tt> <tt class="py-keyword">in</tt> <tt class="py-name">element</tt><tt class="py-op">.</tt><tt class="py-name">childNodes</tt> <tt class="py-keyword">if</tt> <tt class="py-name">isinstance</tt> <tt class="py-op">(</tt><tt class="py-name">e</tt><tt class="py-op">,</tt> <tt class="py-name">minidom</tt><tt class="py-op">.</tt><tt class="py-name">Element</tt><tt class="py-op">)</tt><tt class="py-op">]</tt> </tt>
<a name="L164"></a><tt class="py-lineno">164</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">childElements</tt><tt class="py-op">:</tt> </tt>
<a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line">                        <tt class="py-keyword">for</tt> <tt class="py-name">child</tt> <tt class="py-keyword">in</tt> <tt class="py-name">childElements</tt><tt class="py-op">:</tt> </tt>
<a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line">                                <tt class="py-name">key</tt> <tt class="py-op">=</tt> <tt class="py-name">child</tt><tt class="py-op">.</tt><tt class="py-name">tagName</tt> </tt>
<a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line">                                <tt class="py-keyword">if</tt> <tt class="py-name">hasattr</tt> <tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">,</tt> <tt class="py-name">key</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line">                                        <tt class="py-keyword">if</tt> <tt class="py-name">type</tt> <tt class="py-op">(</tt><tt class="py-name">getattr</tt> <tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">,</tt> <tt class="py-name">key</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> <tt class="py-op">&lt;&gt;</tt> <tt class="py-name">type</tt> <tt class="py-op">(</tt><tt class="py-op">[</tt><tt class="py-op">]</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L169"></a><tt class="py-lineno">169</tt>  <tt class="py-line">                                                <tt class="py-name">setattr</tt> <tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">,</tt> <tt class="py-name">key</tt><tt class="py-op">,</tt> <tt class="py-op">[</tt><tt class="py-name">getattr</tt> <tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">,</tt> <tt class="py-name">key</tt><tt class="py-op">)</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L170"></a><tt class="py-lineno">170</tt>  <tt class="py-line">                                        <tt class="py-name">setattr</tt> <tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">,</tt> <tt class="py-name">key</tt><tt class="py-op">,</tt> <tt class="py-name">getattr</tt> <tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">,</tt> <tt class="py-name">key</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-op">[</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-24" class="py-name" targets="Method screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__unmarshal()=screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#__unmarshal"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__unmarshal" class="py-name" href="#" onclick="return doclink('link-24', '__unmarshal', 'link-24');">__unmarshal</a></tt> <tt class="py-op">(</tt><tt class="py-name">child</tt><tt class="py-op">)</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L171"></a><tt class="py-lineno">171</tt>  <tt class="py-line">                                <tt class="py-keyword">elif</tt> <tt class="py-name">isinstance</tt><tt class="py-op">(</tt><tt class="py-name">child</tt><tt class="py-op">,</tt> <tt class="py-name">minidom</tt><tt class="py-op">.</tt><tt class="py-name">Element</tt><tt class="py-op">)</tt> <tt class="py-keyword">and</tt> <tt class="py-op">(</tt><tt class="py-name">child</tt><tt class="py-op">.</tt><tt class="py-name">tagName</tt> <tt class="py-op">==</tt> <tt class="py-string">'Details'</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L172"></a><tt class="py-lineno">172</tt>  <tt class="py-line">                                        <tt class="py-name">setattr</tt> <tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">,</tt><tt class="py-name">key</tt><tt class="py-op">,</tt><tt class="py-op">[</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-25" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__unmarshal" class="py-name" href="#" onclick="return doclink('link-25', '__unmarshal', 'link-24');">__unmarshal</a></tt><tt class="py-op">(</tt><tt class="py-name">child</tt><tt class="py-op">)</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L173"></a><tt class="py-lineno">173</tt>  <tt class="py-line">                                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L174"></a><tt class="py-lineno">174</tt>  <tt class="py-line">                                        <tt class="py-name">setattr</tt> <tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">,</tt> <tt class="py-name">key</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-26" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__unmarshal" class="py-name" href="#" onclick="return doclink('link-26', '__unmarshal', 'link-24');">__unmarshal</a></tt><tt class="py-op">(</tt><tt class="py-name">child</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L175"></a><tt class="py-lineno">175</tt>  <tt class="py-line">                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L176"></a><tt class="py-lineno">176</tt>  <tt class="py-line">                        <tt class="py-name">rc</tt> <tt class="py-op">=</tt> <tt class="py-string">""</tt><tt class="py-op">.</tt><tt class="py-name">join</tt> <tt class="py-op">(</tt><tt class="py-op">[</tt><tt class="py-name">e</tt><tt class="py-op">.</tt><tt class="py-name">data</tt> <tt class="py-keyword">for</tt> <tt class="py-name">e</tt> <tt class="py-keyword">in</tt> <tt class="py-name">element</tt><tt class="py-op">.</tt><tt class="py-name">childNodes</tt> <tt class="py-keyword">if</tt> <tt class="py-name">isinstance</tt> <tt class="py-op">(</tt><tt class="py-name">e</tt><tt class="py-op">,</tt> <tt class="py-name">minidom</tt><tt class="py-op">.</tt><tt class="py-name">Text</tt><tt class="py-op">)</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L177"></a><tt class="py-lineno">177</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-name">element</tt><tt class="py-op">.</tt><tt class="py-name">tagName</tt> <tt class="py-op">==</tt> <tt class="py-string">'SalesRank'</tt><tt class="py-op">:</tt> </tt>
<a name="L178"></a><tt class="py-lineno">178</tt>  <tt class="py-line">                                <tt class="py-name">rc</tt> <tt class="py-op">=</tt> <tt class="py-name">rc</tt><tt class="py-op">.</tt><tt id="link-27" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-27', 'replace', 'link-12');">replace</a></tt> <tt class="py-op">(</tt><tt class="py-string">'.'</tt><tt class="py-op">,</tt> <tt class="py-string">''</tt><tt class="py-op">)</tt> </tt>
<a name="L179"></a><tt class="py-lineno">179</tt>  <tt class="py-line">                                <tt class="py-name">rc</tt> <tt class="py-op">=</tt> <tt class="py-name">rc</tt><tt class="py-op">.</tt><tt id="link-28" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-28', 'replace', 'link-12');">replace</a></tt> <tt class="py-op">(</tt><tt class="py-string">','</tt><tt class="py-op">,</tt> <tt class="py-string">''</tt><tt class="py-op">)</tt> </tt>
<a name="L180"></a><tt class="py-lineno">180</tt>  <tt class="py-line">                                <tt class="py-name">rc</tt> <tt class="py-op">=</tt> <tt class="py-name">int</tt> <tt class="py-op">(</tt><tt class="py-name">rc</tt><tt class="py-op">)</tt> </tt>
<a name="L181"></a><tt class="py-lineno">181</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">rc</tt> </tt>
</div><a name="L182"></a><tt class="py-lineno">182</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.on_search_response"></a><div id="AmazonCoverArtSearch.on_search_response-def"><a name="L183"></a><tt class="py-lineno">183</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.on_search_response-toggle" onclick="return toggle('AmazonCoverArtSearch.on_search_response');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#on_search_response">on_search_response</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">result_data</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.on_search_response-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.on_search_response-expanded"><a name="L184"></a><tt class="py-lineno">184</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">result_data</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L185"></a><tt class="py-lineno">185</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-29" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.search_next" class="py-name" href="#" onclick="return doclink('link-29', 'search_next', 'link-14');">search_next</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L186"></a><tt class="py-lineno">186</tt>  <tt class="py-line">                        <tt class="py-keyword">return</tt> </tt>
<a name="L187"></a><tt class="py-lineno">187</tt>  <tt class="py-line"> </tt>
<a name="L188"></a><tt class="py-lineno">188</tt>  <tt class="py-line">                <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L189"></a><tt class="py-lineno">189</tt>  <tt class="py-line">                        <tt class="py-name">xmldoc</tt> <tt class="py-op">=</tt> <tt class="py-name">minidom</tt><tt class="py-op">.</tt><tt class="py-name">parseString</tt> <tt class="py-op">(</tt><tt class="py-name">result_data</tt><tt class="py-op">)</tt> </tt>
<a name="L190"></a><tt class="py-lineno">190</tt>  <tt class="py-line">                <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L191"></a><tt class="py-lineno">191</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-30" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.search_next" class="py-name" href="#" onclick="return doclink('link-30', 'search_next', 'link-14');">search_next</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L192"></a><tt class="py-lineno">192</tt>  <tt class="py-line">                        <tt class="py-keyword">return</tt> </tt>
<a name="L193"></a><tt class="py-lineno">193</tt>  <tt class="py-line">                 </tt>
<a name="L194"></a><tt class="py-lineno">194</tt>  <tt class="py-line">                <tt class="py-name">data</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-31" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__unmarshal" class="py-name" href="#" onclick="return doclink('link-31', '__unmarshal', 'link-24');">__unmarshal</a></tt> <tt class="py-op">(</tt><tt class="py-name">xmldoc</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">ProductInfo</tt> </tt>
<a name="L195"></a><tt class="py-lineno">195</tt>  <tt class="py-line"> </tt>
<a name="L196"></a><tt class="py-lineno">196</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">hasattr</tt><tt class="py-op">(</tt><tt class="py-name">data</tt><tt class="py-op">,</tt> <tt class="py-string">'ErrorMsg'</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L197"></a><tt class="py-lineno">197</tt>  <tt class="py-line">                        <tt class="py-comment"># Search was unsuccessful, try next keyword</tt> </tt>
<a name="L198"></a><tt class="py-lineno">198</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-32" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.search_next" class="py-name" href="#" onclick="return doclink('link-32', 'search_next', 'link-14');">search_next</a></tt> <tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L199"></a><tt class="py-lineno">199</tt>  <tt class="py-line">                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L200"></a><tt class="py-lineno">200</tt>  <tt class="py-line">                        <tt class="py-comment"># We got some search results</tt> </tt>
<a name="L201"></a><tt class="py-lineno">201</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-33" class="py-name" targets="Method screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.on_search_results()=screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#on_search_results"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.on_search_results" class="py-name" href="#" onclick="return doclink('link-33', 'on_search_results', 'link-33');">on_search_results</a></tt> <tt class="py-op">(</tt><tt class="py-name">data</tt><tt class="py-op">.</tt><tt class="py-name">Details</tt><tt class="py-op">)</tt> </tt>
</div><a name="L202"></a><tt class="py-lineno">202</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.on_search_results"></a><div id="AmazonCoverArtSearch.on_search_results-def"><a name="L203"></a><tt class="py-lineno">203</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.on_search_results-toggle" onclick="return toggle('AmazonCoverArtSearch.on_search_results');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#on_search_results">on_search_results</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">results</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.on_search_results-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.on_search_results-expanded"><a name="L204"></a><tt class="py-lineno">204</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-34" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.on_search_completed" class="py-name" href="#" onclick="return doclink('link-34', 'on_search_completed', 'link-18');">on_search_completed</a></tt> <tt class="py-op">(</tt><tt class="py-name">results</tt><tt class="py-op">)</tt> </tt>
</div><a name="L205"></a><tt class="py-lineno">205</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.on_search_completed"></a><div id="AmazonCoverArtSearch.on_search_completed-def"><a name="L206"></a><tt class="py-lineno">206</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.on_search_completed-toggle" onclick="return toggle('AmazonCoverArtSearch.on_search_completed');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#on_search_completed">on_search_completed</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">result</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.on_search_completed-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.on_search_completed-expanded"><a name="L207"></a><tt class="py-lineno">207</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">on_search_completed_callback</tt> <tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-35" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.artist" class="py-name" href="#" onclick="return doclink('link-35', 'artist', 'link-8');">artist</a></tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-36" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.album" class="py-name" href="#" onclick="return doclink('link-36', 'album', 'link-6');">album</a></tt><tt class="py-op">,</tt> <tt class="py-name">result</tt><tt class="py-op">,</tt> <tt class="py-op">*</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">args</tt><tt class="py-op">)</tt> </tt>
<a name="L208"></a><tt class="py-lineno">208</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">searching</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt> </tt>
</div><a name="L209"></a><tt class="py-lineno">209</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.__tidy_up_string"></a><div id="AmazonCoverArtSearch.__tidy_up_string-def"><a name="L210"></a><tt class="py-lineno">210</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.__tidy_up_string-toggle" onclick="return toggle('AmazonCoverArtSearch.__tidy_up_string');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#__tidy_up_string">__tidy_up_string</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.__tidy_up_string-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.__tidy_up_string-expanded"><a name="L211"></a><tt class="py-lineno">211</tt>  <tt class="py-line">                <tt class="py-comment"># Lowercase</tt> </tt>
<a name="L212"></a><tt class="py-lineno">212</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">s</tt> <tt class="py-op">=</tt> <tt class="py-name">s</tt><tt class="py-op">.</tt><tt class="py-name">lower</tt> <tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L213"></a><tt class="py-lineno">213</tt>  <tt class="py-line">                <tt class="py-comment"># Strip</tt> </tt>
<a name="L214"></a><tt class="py-lineno">214</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">s</tt> <tt class="py-op">=</tt> <tt class="py-name">s</tt><tt class="py-op">.</tt><tt class="py-name">strip</tt> <tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L215"></a><tt class="py-lineno">215</tt>  <tt class="py-line"> </tt>
<a name="L216"></a><tt class="py-lineno">216</tt>  <tt class="py-line">                <tt class="py-comment"># TODO: Convert accented to unaccented (fixes matching Salom&#233; vs Salome)</tt> </tt>
<a name="L217"></a><tt class="py-lineno">217</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">s</tt> <tt class="py-op">=</tt> <tt class="py-name">s</tt><tt class="py-op">.</tt><tt id="link-37" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-37', 'replace', 'link-12');">replace</a></tt> <tt class="py-op">(</tt><tt class="py-string">" - "</tt><tt class="py-op">,</tt> <tt class="py-string">" "</tt><tt class="py-op">)</tt>       </tt>
<a name="L218"></a><tt class="py-lineno">218</tt>  <tt class="py-line">                <tt class="py-name">s</tt> <tt class="py-op">=</tt> <tt class="py-name">s</tt><tt class="py-op">.</tt><tt id="link-38" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-38', 'replace', 'link-12');">replace</a></tt> <tt class="py-op">(</tt><tt class="py-string">": "</tt><tt class="py-op">,</tt> <tt class="py-string">" "</tt><tt class="py-op">)</tt> </tt>
<a name="L219"></a><tt class="py-lineno">219</tt>  <tt class="py-line">                <tt class="py-name">s</tt> <tt class="py-op">=</tt> <tt class="py-name">s</tt><tt class="py-op">.</tt><tt id="link-39" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-39', 'replace', 'link-12');">replace</a></tt> <tt class="py-op">(</tt><tt class="py-string">" &amp; "</tt><tt class="py-op">,</tt> <tt class="py-string">" and "</tt><tt class="py-op">)</tt> </tt>
<a name="L220"></a><tt class="py-lineno">220</tt>  <tt class="py-line"> </tt>
<a name="L221"></a><tt class="py-lineno">221</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">s</tt> </tt>
</div><a name="L222"></a><tt class="py-lineno">222</tt>  <tt class="py-line"> </tt>
<a name="AmazonCoverArtSearch.get_best_match_urls"></a><div id="AmazonCoverArtSearch.get_best_match_urls-def"><a name="L223"></a><tt class="py-lineno">223</tt> <a class="py-toggle" href="#" id="AmazonCoverArtSearch.get_best_match_urls-toggle" onclick="return toggle('AmazonCoverArtSearch.get_best_match_urls');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#get_best_match_urls">get_best_match_urls</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">search_results</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="AmazonCoverArtSearch.get_best_match_urls-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="AmazonCoverArtSearch.get_best_match_urls-expanded"><a name="L224"></a><tt class="py-lineno">224</tt>  <tt class="py-line">                <tt class="py-comment"># Default to "no match", our results must match our criteria</tt> </tt>
<a name="L225"></a><tt class="py-lineno">225</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">best_match</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L226"></a><tt class="py-lineno">226</tt>  <tt class="py-line"> </tt>
<a name="L227"></a><tt class="py-lineno">227</tt>  <tt class="py-line">                <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L228"></a><tt class="py-lineno">228</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">search_album</tt> <tt class="py-op">!=</tt> <tt class="py-string">"Unknown"</tt><tt class="py-op">:</tt> </tt>
<a name="L229"></a><tt class="py-lineno">229</tt>  <tt class="py-line">                                <tt class="py-name">album_check</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-40" class="py-name" targets="Method screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__tidy_up_string()=screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch-class.html#__tidy_up_string"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__tidy_up_string" class="py-name" href="#" onclick="return doclink('link-40', '__tidy_up_string', 'link-40');">__tidy_up_string</a></tt> <tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">search_album</tt><tt class="py-op">)</tt> </tt>
<a name="L230"></a><tt class="py-lineno">230</tt>  <tt class="py-line">                                <tt class="py-keyword">for</tt> <tt class="py-name">item</tt> <tt class="py-keyword">in</tt> <tt class="py-name">search_results</tt><tt class="py-op">:</tt> </tt>
<a name="L231"></a><tt class="py-lineno">231</tt>  <tt class="py-line">                                        <tt class="py-comment"># Check for album name in ProductName</tt> </tt>
<a name="L232"></a><tt class="py-lineno">232</tt>  <tt class="py-line"><tt class="py-comment"></tt>                                        <tt class="py-name">product_name</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-41" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__tidy_up_string" class="py-name" href="#" onclick="return doclink('link-41', '__tidy_up_string', 'link-40');">__tidy_up_string</a></tt> <tt class="py-op">(</tt><tt class="py-name">item</tt><tt class="py-op">.</tt><tt class="py-name">ProductName</tt><tt class="py-op">)</tt> </tt>
<a name="L233"></a><tt class="py-lineno">233</tt>  <tt class="py-line"> </tt>
<a name="L234"></a><tt class="py-lineno">234</tt>  <tt class="py-line">                                        <tt class="py-keyword">if</tt> <tt class="py-name">product_name</tt> <tt class="py-op">==</tt> <tt class="py-name">album_check</tt><tt class="py-op">:</tt> </tt>
<a name="L235"></a><tt class="py-lineno">235</tt>  <tt class="py-line">                                                <tt class="py-comment"># Found exact album, can not get better than that</tt> </tt>
<a name="L236"></a><tt class="py-lineno">236</tt>  <tt class="py-line"><tt class="py-comment"></tt>                                                <tt class="py-name">best_match</tt> <tt class="py-op">=</tt> <tt class="py-name">item</tt> </tt>
<a name="L237"></a><tt class="py-lineno">237</tt>  <tt class="py-line">                                                <tt class="py-keyword">break</tt> </tt>
<a name="L238"></a><tt class="py-lineno">238</tt>  <tt class="py-line">                                        <tt class="py-comment"># If we already found a best_match, just keep checking for exact one</tt> </tt>
<a name="L239"></a><tt class="py-lineno">239</tt>  <tt class="py-line"><tt class="py-comment"></tt>                                        <tt class="py-keyword">elif</tt> <tt class="py-op">(</tt><tt class="py-name">best_match</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt> <tt class="py-keyword">and</tt> <tt class="py-op">(</tt><tt class="py-name">product_name</tt><tt class="py-op">.</tt><tt class="py-name">find</tt> <tt class="py-op">(</tt><tt class="py-name">album_check</tt><tt class="py-op">)</tt> <tt class="py-op">!=</tt> <tt class="py-op">-</tt><tt class="py-number">1</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L240"></a><tt class="py-lineno">240</tt>  <tt class="py-line">                                                <tt class="py-name">best_match</tt> <tt class="py-op">=</tt> <tt class="py-name">item</tt> </tt>
<a name="L241"></a><tt class="py-lineno">241</tt>  <tt class="py-line"> </tt>
<a name="L242"></a><tt class="py-lineno">242</tt>  <tt class="py-line">                        <tt class="py-comment"># If we still have no definite hit, use first result where artist matches</tt> </tt>
<a name="L243"></a><tt class="py-lineno">243</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt class="py-keyword">if</tt> <tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">search_album</tt> <tt class="py-op">==</tt> <tt class="py-string">"Unknown"</tt> <tt class="py-keyword">and</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">search_artist</tt> <tt class="py-op">!=</tt> <tt class="py-string">"Unknown"</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L244"></a><tt class="py-lineno">244</tt>  <tt class="py-line">                                <tt class="py-name">artist_check</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-42" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__tidy_up_string" class="py-name" href="#" onclick="return doclink('link-42', '__tidy_up_string', 'link-40');">__tidy_up_string</a></tt> <tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">search_artist</tt><tt class="py-op">)</tt> </tt>
<a name="L245"></a><tt class="py-lineno">245</tt>  <tt class="py-line">                                <tt class="py-keyword">if</tt> <tt class="py-name">best_match</tt> <tt class="py-keyword">is</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L246"></a><tt class="py-lineno">246</tt>  <tt class="py-line">                                        <tt class="py-comment"># Check if artist appears in the Artists list</tt> </tt>
<a name="L247"></a><tt class="py-lineno">247</tt>  <tt class="py-line"><tt class="py-comment"></tt>                                        <tt class="py-name">hit</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt> </tt>
<a name="L248"></a><tt class="py-lineno">248</tt>  <tt class="py-line">                                        <tt class="py-keyword">for</tt> <tt class="py-name">item</tt> <tt class="py-keyword">in</tt> <tt class="py-name">search_results</tt><tt class="py-op">:</tt> </tt>
<a name="L249"></a><tt class="py-lineno">249</tt>  <tt class="py-line">                                                <tt class="py-keyword">if</tt> <tt class="py-name">type</tt> <tt class="py-op">(</tt><tt class="py-name">item</tt><tt class="py-op">.</tt><tt class="py-name">Artists</tt><tt class="py-op">.</tt><tt class="py-name">Artist</tt><tt class="py-op">)</tt> <tt class="py-op">&lt;&gt;</tt> <tt class="py-name">type</tt> <tt class="py-op">(</tt><tt class="py-op">[</tt><tt class="py-op">]</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L250"></a><tt class="py-lineno">250</tt>  <tt class="py-line">                                                        <tt class="py-name">artists</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-name">item</tt><tt class="py-op">.</tt><tt class="py-name">Artists</tt><tt class="py-op">.</tt><tt class="py-name">Artist</tt><tt class="py-op">]</tt> </tt>
<a name="L251"></a><tt class="py-lineno">251</tt>  <tt class="py-line">                                                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L252"></a><tt class="py-lineno">252</tt>  <tt class="py-line">                                                        <tt class="py-name">artists</tt> <tt class="py-op">=</tt> <tt class="py-name">item</tt><tt class="py-op">.</tt><tt class="py-name">Artists</tt><tt class="py-op">.</tt><tt class="py-name">Artist</tt> </tt>
<a name="L253"></a><tt class="py-lineno">253</tt>  <tt class="py-line"> </tt>
<a name="L254"></a><tt class="py-lineno">254</tt>  <tt class="py-line">                                                <tt class="py-keyword">for</tt> <tt id="link-43" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.artist" class="py-name" href="#" onclick="return doclink('link-43', 'artist', 'link-8');">artist</a></tt> <tt class="py-keyword">in</tt> <tt class="py-name">artists</tt><tt class="py-op">:</tt> </tt>
<a name="L255"></a><tt class="py-lineno">255</tt>  <tt class="py-line">                                                        <tt id="link-44" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.artist" class="py-name" href="#" onclick="return doclink('link-44', 'artist', 'link-8');">artist</a></tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-45" class="py-name"><a title="screenlets.plugins.AmazonCoverArtSearch.AmazonCoverArtSearch.__tidy_up_string" class="py-name" href="#" onclick="return doclink('link-45', '__tidy_up_string', 'link-40');">__tidy_up_string</a></tt> <tt class="py-op">(</tt><tt id="link-46" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.artist" class="py-name" href="#" onclick="return doclink('link-46', 'artist', 'link-8');">artist</a></tt><tt class="py-op">)</tt> </tt>
<a name="L256"></a><tt class="py-lineno">256</tt>  <tt class="py-line">                                                        <tt class="py-keyword">if</tt> <tt id="link-47" class="py-name"><a title="screenlets.plugins.CoverSearch.CoverSearch.artist" class="py-name" href="#" onclick="return doclink('link-47', 'artist', 'link-8');">artist</a></tt><tt class="py-op">.</tt><tt class="py-name">find</tt> <tt class="py-op">(</tt><tt class="py-name">artist_check</tt><tt class="py-op">)</tt> <tt class="py-op">!=</tt> <tt class="py-op">-</tt><tt class="py-number">1</tt><tt class="py-op">:</tt> </tt>
<a name="L257"></a><tt class="py-lineno">257</tt>  <tt class="py-line">                                                                <tt class="py-name">best_match</tt> <tt class="py-op">=</tt> <tt class="py-name">item</tt> </tt>
<a name="L258"></a><tt class="py-lineno">258</tt>  <tt class="py-line">                                                                <tt class="py-name">hit</tt> <tt class="py-op">=</tt> <tt class="py-name">True</tt>                                               </tt>
<a name="L259"></a><tt class="py-lineno">259</tt>  <tt class="py-line">                                                                <tt class="py-keyword">break</tt> </tt>
<a name="L260"></a><tt class="py-lineno">260</tt>  <tt class="py-line">                                                <tt class="py-keyword">if</tt> <tt class="py-name">hit</tt><tt class="py-op">:</tt> </tt>
<a name="L261"></a><tt class="py-lineno">261</tt>  <tt class="py-line">                                                        <tt class="py-keyword">break</tt> </tt>
<a name="L262"></a><tt class="py-lineno">262</tt>  <tt class="py-line"> </tt>
<a name="L263"></a><tt class="py-lineno">263</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-name">best_match</tt><tt class="py-op">:</tt>  </tt>
<a name="L264"></a><tt class="py-lineno">264</tt>  <tt class="py-line">                                <tt class="py-keyword">return</tt> <tt class="py-op">[</tt><tt class="py-name">best_match</tt><tt class="py-op">.</tt><tt class="py-name">ImageUrlLarge</tt><tt class="py-op">,</tt> <tt class="py-name">best_match</tt><tt class="py-op">.</tt><tt class="py-name">ImageUrlMedium</tt><tt class="py-op">]</tt> </tt>
<a name="L265"></a><tt class="py-lineno">265</tt>  <tt class="py-line">                        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L266"></a><tt class="py-lineno">266</tt>  <tt class="py-line">                                <tt class="py-keyword">return</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
<a name="L267"></a><tt class="py-lineno">267</tt>  <tt class="py-line"> </tt>
<a name="L268"></a><tt class="py-lineno">268</tt>  <tt class="py-line">                <tt class="py-keyword">except</tt> <tt class="py-name">TypeError</tt><tt class="py-op">:</tt> </tt>
<a name="L269"></a><tt class="py-lineno">269</tt>  <tt class="py-line">                        <tt class="py-keyword">return</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt> </tt>
</div></div><a name="L270"></a><tt class="py-lineno">270</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="screenlets-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            >Screenlets 0.1.2</th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0beta1 on Wed Jun  4 18:53:01 2008
    </td>
    <td align="right" class="footer">
      <a href="http://epydoc.sourceforge.net">http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie()
  // -->
</script>
  
</body>
</html>
